/*
 * Member API
 *
 * Member API routes and contracts.
 *
 * The version of the OpenAPI document: 1.0.0
 *
 * Generated by: https://openapi-generator.tech
 */

use reqwest;

use super::{configuration, Error};
use crate::apis::ResponseContent;

/// struct for typed errors of method `get_book_transfers`
#[derive(Debug, Clone, Serialize, Deserialize)]
#[serde(untagged)]
pub enum GetBookTransfersError {
    Status400(crate::models::InlineResponse400),
    Status403(crate::models::InlineResponse403),
    Status404(crate::models::InlineResponse404),
    UnknownValue(serde_json::Value),
}

/// Retrieves book tranfers in reverse order of their create date. (Most recently created are returned first)
pub async fn get_book_transfers(
    configuration: &configuration::Configuration,
    from_date: &str,
    to_date: &str,
    page_cursor: Option<&str>,
) -> Result<crate::models::BookTransfers, Error<GetBookTransfersError>> {
    let local_var_client = &configuration.client;

    let local_var_uri_str = format!("{}/book", configuration.base_path);
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::GET, local_var_uri_str.as_str());

    local_var_req_builder = local_var_req_builder.query(&[("from_date", &from_date.to_string())]);
    local_var_req_builder = local_var_req_builder.query(&[("to_date", &to_date.to_string())]);
    if let Some(ref local_var_str) = page_cursor {
        local_var_req_builder =
            local_var_req_builder.query(&[("page_cursor", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_user_agent) = configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_auth_conf) = configuration.basic_auth {
        local_var_req_builder = local_var_req_builder.basic_auth(
            local_var_auth_conf.0.to_owned(),
            local_var_auth_conf.1.to_owned(),
        );
    };

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<GetBookTransfersError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}
